import * as vue from 'vue';
import { SetupContext } from 'vue';
import { UnionStringArray } from '@chakra-ui/utils';

declare const inputTypes: readonly ["button", "checkbox", "color", "date", "datetime-local", "email", "file", "hidden", "image", "month", "number", "password", "radio", "range", "reset", "search", "submit", "tel", "text", "time", "url", "week"];
type InputTypes = UnionStringArray<typeof inputTypes>;
interface FormElementProps {
    emits: string[];
    props: Record<string, unknown>;
    handleValueChange: (props: any, type?: InputTypes) => (emit: SetupContext["emit"]) => Record<string, unknown>;
}
declare const formElements: Record<string, FormElementProps>;
type ChakraFactoryElements = "input" | "select" | "textarea";
declare function useFormElement(element: ChakraFactoryElements, props: any): {
    elProps: vue.ComputedRef<{
        checked: any;
        value: any;
    }>;
};

export { ChakraFactoryElements, FormElementProps, InputTypes, formElements, useFormElement };
