"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/chakra.forms.ts
var chakra_forms_exports = {};
__export(chakra_forms_exports, {
  formElements: () => formElements,
  useFormElement: () => useFormElement
});
module.exports = __toCommonJS(chakra_forms_exports);
var import_vue = require("vue");
var formElements = {
  input: {
    emits: ["input", "change", "onUpdate:modelValue"],
    props: {
      modelValue: [Boolean, String]
    },
    handleValueChange(props, type) {
      return (emit) => {
        return {
          ...type === "checkbox" && {
            checked: props.modelValue
          },
          onChange: (event) => {
            if (type === "checkbox") {
              emit("change", !(event == null ? void 0 : event.target).checked, event);
              emit("update:modelValue", !(event == null ? void 0 : event.target).checked, event);
              return;
            }
          },
          onInput: (event) => {
            emit("input", (event == null ? void 0 : event.currentTarget).value, event);
            emit("update:modelValue", (event == null ? void 0 : event.currentTarget).value, event);
          }
        };
      };
    }
  },
  textarea: {
    emits: ["input", "change", "onUpdate:modelValue"],
    props: {
      modelValue: [Boolean, String]
    },
    handleValueChange(props, type) {
      return (emit) => {
        return {
          onInput: (event) => {
            emit("input", (event == null ? void 0 : event.currentTarget).value, event);
            emit("update:modelValue", (event == null ? void 0 : event.currentTarget).value, event);
          }
        };
      };
    }
  },
  select: {
    emits: ["input", "change", "onUpdate:modelValue"],
    props: {
      modelValue: [Boolean, String]
    },
    handleValueChange(props, type) {
      return (emit) => {
        return {
          onChange: (event) => {
            emit("input", (event == null ? void 0 : event.currentTarget).value, event);
            emit("update:modelValue", (event == null ? void 0 : event.currentTarget).value, event);
          }
        };
      };
    }
  }
};
function useFormElement(element, props) {
  const instance = (0, import_vue.getCurrentInstance)();
  const uid = (0, import_vue.computed)(() => (instance == null ? void 0 : instance.uid) || Date.now());
  const elProps = (0, import_vue.computed)(() => ({
    checked: props.modelValue,
    value: props.moddelValue
  }));
  return {
    elProps
  };
}
__name(useFormElement, "useFormElement");
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  formElements,
  useFormElement
});
