import {
  __name
} from "./chunk-UP4IWT5Y.mjs";

// src/chakra.forms.ts
import { computed, getCurrentInstance } from "vue";
var formElements = {
  input: {
    emits: ["input", "change", "onUpdate:modelValue"],
    props: {
      modelValue: [Boolean, String]
    },
    handleValueChange(props, type) {
      return (emit) => {
        return {
          ...type === "checkbox" && {
            checked: props.modelValue
          },
          onChange: (event) => {
            if (type === "checkbox") {
              emit("change", !(event == null ? void 0 : event.target).checked, event);
              emit("update:modelValue", !(event == null ? void 0 : event.target).checked, event);
              return;
            }
          },
          onInput: (event) => {
            emit("input", (event == null ? void 0 : event.currentTarget).value, event);
            emit("update:modelValue", (event == null ? void 0 : event.currentTarget).value, event);
          }
        };
      };
    }
  },
  textarea: {
    emits: ["input", "change", "onUpdate:modelValue"],
    props: {
      modelValue: [Boolean, String]
    },
    handleValueChange(props, type) {
      return (emit) => {
        return {
          onInput: (event) => {
            emit("input", (event == null ? void 0 : event.currentTarget).value, event);
            emit("update:modelValue", (event == null ? void 0 : event.currentTarget).value, event);
          }
        };
      };
    }
  },
  select: {
    emits: ["input", "change", "onUpdate:modelValue"],
    props: {
      modelValue: [Boolean, String]
    },
    handleValueChange(props, type) {
      return (emit) => {
        return {
          onChange: (event) => {
            emit("input", (event == null ? void 0 : event.currentTarget).value, event);
            emit("update:modelValue", (event == null ? void 0 : event.currentTarget).value, event);
          }
        };
      };
    }
  }
};
function useFormElement(element, props) {
  const instance = getCurrentInstance();
  const uid = computed(() => (instance == null ? void 0 : instance.uid) || Date.now());
  const elProps = computed(() => ({
    checked: props.modelValue,
    value: props.moddelValue
  }));
  return {
    elProps
  };
}
__name(useFormElement, "useFormElement");

export {
  formElements,
  useFormElement
};
