import {
  useChakra
} from "./chunk-ENN7VG77.mjs";
import {
  __name
} from "./chunk-UP4IWT5Y.mjs";

// src/composables/use-style-config.ts
import { computed } from "vue";
import { filterUndefined, get, mergeWith, runIfFn } from "@chakra-ui/utils";
function useStyleConfig(themeKey, themingProps, options = {}) {
  return computed(() => {
    var _a, _b, _c, _d, _e, _f, _g;
    const {
      styleConfig: styleConfigProp,
      ...rest
    } = themingProps.value || themingProps;
    const {
      theme,
      colorMode
    } = useChakra();
    const themeStyleConfig = get(theme, `components.${themeKey}`);
    const styleConfig = styleConfigProp || themeStyleConfig;
    const mergedProps = mergeWith({
      theme,
      colorMode: colorMode.value
    }, (_a = styleConfig == null ? void 0 : styleConfig.defaultProps) != null ? _a : {}, filterUndefined(rest));
    const baseStyles = runIfFn((_b = styleConfig == null ? void 0 : styleConfig.baseStyle) != null ? _b : {}, mergedProps);
    const variants = runIfFn((_d = (_c = styleConfig == null ? void 0 : styleConfig.variants) == null ? void 0 : _c[mergedProps.variant]) != null ? _d : {}, mergedProps);
    const sizes = runIfFn((_f = (_e = styleConfig == null ? void 0 : styleConfig.sizes) == null ? void 0 : _e[mergedProps.size]) != null ? _f : {}, mergedProps);
    const styles = mergeWith({}, baseStyles, sizes, variants);
    if (options.isMultiPart && (styleConfig == null ? void 0 : styleConfig.parts)) {
      (_g = styleConfig == null ? void 0 : styleConfig.parts) == null ? void 0 : _g.forEach((part) => {
        var _a2;
        styles[part] = (_a2 = styles[part]) != null ? _a2 : {};
      });
    }
    return styles;
  });
}
__name(useStyleConfig, "useStyleConfig");
function useMultiStyleConfig(themeKey, themingProps) {
  return useStyleConfig(themeKey, themingProps, {
    isMultiPart: true
  });
}
__name(useMultiStyleConfig, "useMultiStyleConfig");

export {
  useStyleConfig,
  useMultiStyleConfig
};
