import { ComputedRef, Ref } from 'vue';
import { ThemingProps, SystemStyleObject } from '@chakra-ui/styled-system';
import { Theme } from '@chakra-ui/theme';

declare function useStyleConfig<Component extends keyof Theme["components"]>(themeKey: Component, themingProps: ThemingProps, options: {
    isMultiPart: true;
}): ComputedRef<Record<string, SystemStyleObject>>;
declare function useStyleConfig<Component extends keyof Theme["components"]>(themeKey: Component, themingProps: Ref<ThemingProps>, options: {
    isMultiPart: true;
}): ComputedRef<Record<string, SystemStyleObject>>;
declare function useStyleConfig<Component extends keyof Theme["components"]>(themeKey: Component, themingProps?: ThemingProps, options?: {
    isMultiPart?: boolean;
}): ComputedRef<SystemStyleObject>;
declare function useStyleConfig<Component extends keyof Theme["components"]>(themeKey: Component, themingProps?: Ref<ThemingProps>, options?: {
    isMultiPart?: boolean;
}): ComputedRef<SystemStyleObject>;
declare function useMultiStyleConfig<Component extends keyof Theme["components"]>(themeKey: Component, themingProps: any): ComputedRef<Record<string, SystemStyleObject>>;

export { useMultiStyleConfig, useStyleConfig };
