import { Dict } from '@chakra-ui/utils';
import { SystemStyleObject } from '@chakra-ui/styled-system';
import { ComputedRef } from 'vue';

declare const StylesProvider: (opts: ComputedRef<Dict<SystemStyleObject>>) => void;
declare const useStyles: (fallback?: ComputedRef<Dict<SystemStyleObject>> | undefined) => ComputedRef<Dict<SystemStyleObject>>;

declare const createStylesContext: (componentName: string) => [(opts: ComputedRef<Record<string, SystemStyleObject>>) => void, (fallback?: ComputedRef<Record<string, SystemStyleObject>> | undefined) => ComputedRef<Record<string, SystemStyleObject>>, Symbol];

export { StylesProvider, createStylesContext, useStyles };
